Attribute VB_Name = "Win32ver"
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
(lpVersionInformation As OSVERSIONINFO) As Long

Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128  'Maintenance string for PSS usage
End Type

Private Const VER_PLATFORM_WIN32_NT = 2
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32s = 0

'Um die angeforderten Informationen nun auszuwerten braucht es noch einiger Informationen.
'So erhlt man mit der PlatformID nicht etwa direkt das Betriebssystem(auer NT) sondern
'einen Hinwei auf dieses. Bei Windows 95/98 mu danach noch die Versionsnummer untersucht
'werden. So ist Windows 98 immer mit einer x.10 gesegnet.

'Im Array .szCSDVersion aus der OSVERSIONINFO-Struktur stehen dann solche Sachen wie
'die Version des ServicePacks. Das Array ist vbNullString-getrennt und wird hier mit der Funktion
'Split() getrennt, die aber erst seit Version 6 von VB verfgbar ist(ist aber kein Grund fr mich
'darauf zu verzichten...). Wenn man die Funktion auch unter VB5 haben will, dann sollte man
'sich das Modul "VB6 Modul" unter Tools mal anschauen.

'Windows Me = Version 4.90
'Windows XP = Version 5.1

'Betriebssystem mit Informationen
Public Function WinOSVersion() As String
    Dim OSinfo As OSVERSIONINFO, CSDArray() As String, CSD As String, tmp
    OSinfo.dwOSVersionInfoSize = Len(OSinfo)
    GetVersionEx OSinfo
    
    With OSinfo
    Select Case .dwPlatformId
        Case VER_PLATFORM_WIN32s
        OS = "Windows 16bit mit 32bit-Erweiterung"
        Case VER_PLATFORM_WIN32_WINDOWS
        OS = "Windows"
            Select Case .dwMinorVersion
            Case 0
            OS = OS & " 95"
            Case 10
            OS = OS & " 98"
            Case 90
            OS = OS & " Me"
            Case Else
            OS = OS & " (unbekannt)"
            End Select
        Case VER_PLATFORM_WIN32_NT
            OS = "Windows Nt"
        Case Else
            OS = "Betriebssystem unbekannt"
    End Select
    
    'VERSIONSNUMMER HINZUFGEN
    OS = OS & " (Version " & .dwMajorVersion & "." & .dwMinorVersion & ")"
    End With
    
    WinOSVersion = OS
End Function

